<template>
  <div
    class="ui modal"
    id="new-variant-modal"
  >
    <i class="close icon"></i>
    <div class="header">
      Ajouter une variante
    </div>
    <div class="content">
      <h5>
        {{ dishesMainMenu.dishes ? dishesMainMenu.dishes.join(', ') : '' }}
      </h5>
      <form
        class="ui form"
        @submit.prevent="submit"
      >
        <div class="fields">
          <div class="twelve wide required field">
            <label>Régime</label>
            <dropdown-diet
              :initialDiets="diets"
              @dietChanged="updateDiet"
            >
            </dropdown-diet>
            <br/>

          </div>
        </div>
        <div class="fields">
          <div class="twelve wide required field">
            <label>Plats</label>
            <input
              placeholder="Séparés par des virgules "
              type="text"
              required
              v-model="dishes"
            >
          </div>
        </div>
      </form>
    </div>
    <div class="actions">
      <div
        class="ui toggle checkbox"
        @click="toggleAddAnother"
      >
        <input
          name="addAnother"
          type="checkbox"
          class="hidden"
          tabindex="0"
          :checked="addAnother"
        >
        <label>Ajouter un autre ensuite</label>
      </div>

      <div
        class="ui red basic button"
        @click="cancel"
      >Anuler</div>

      <div
        class="ui primary button"
        :class="loading ? 'loading disabled' : ''"
        @click="submit"
      >OK</div>
    </div>
  </div>

</template>

<script>
import { mapActions, mapGetters } from 'vuex'

import store from '@/store/Store'
import MenusStore from '@/store/modules/menus/MenusStore'
import DropdownDiet from '@/components/diets/DropdownDiet'

export default {
  name: 'ModalNewVariant',
  store,
  props: {
    menuBaseId: String
  },
  data () {
    return {
      addAnother: false,
      diet: '',
      dishes: ''
    }
  },
  mounted () {
    // eslint-disable-next-line
    $('#new-variant-modal')
      .modal('setting', 'transition', 'scale')
  },
  methods: {
    ...mapActions({
      addVariant: 'MenuVariantsStore/addMenuVariant'
    }),
    toggleAddAnother () {
      this.addAnother = !this.addAnother
    },
    updateDiet (id) {
      this.diet = id
    },
    cancel () {
      // eslint-disable-next-line
      $('#new-variant-modal')
        .modal('hide')
    },
    submit () {
      var self = this

      let variant = {
        diet: { _id: this.diet },
        menuBase: this.menuBaseId
      }

      if (this.dishes !== '') {
        variant.dishes = this.dishes.split(',').map(s => s.trim())
      }

      console.log('new variant: ', variant)

      this.addVariant(variant)
        .then((response) => {
          this.$toastr.s('Bien ajoutée')
          if (!self.addAnother) {
            // eslint-disable-next-line
            $('#new-variant-modal')
              .modal('hide')
          }
          this.emptyModal()
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        })
    },
    emptyModal () {
      // vider les champs
      this.dishes = ''
    }
  },
  computed: {
    ...mapGetters({
      loading: 'loading',
      diets: 'DietsStore/diets'
    }),
    dishesMainMenu () {
      if (this.menuBaseId !== '') {
        return MenusStore.getters.menuById(MenusStore.state)(this.menuBaseId)
      } else {
        return null
      }
    }
  },
  components: {
    DropdownDiet
  }
}
</script>
